package pps.core.prediction.service;

import cn.hutool.core.text.CharSequenceUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.core.prediction.entity.PlantPowerDataEnt;
import pps.core.prediction.mapper.PlantPowerDataMapper;
import pps.core.prediction.service.data.plant_power_data.QueryPlantPowerDataInput;
import pps.core.prediction.service.data.plant_power_data.QueryPlantPowerDataOutput;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XPageResult;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.mybatis.helper.XMapperHelper;

@XService
@XText("电站实际发电数据")
public class PlantPowerDataService {

    @XApiGet
    public XPageResult<QueryPlantPowerDataOutput> queryPlantPowerDataList(XContext context, QueryPlantPowerDataInput input) {
        PlantPowerDataMapper mapper = context.getBean(PlantPowerDataMapper.class);
        QueryWrapper<PlantPowerDataEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(PlantPowerDataEnt::getPlantId, input.getPlantId());
        if (CharSequenceUtil.isNotBlank(input.getStartTime()))
            queryWrapper.lambda().ge(PlantPowerDataEnt::getDataDate, input.getStartTime());
        if (CharSequenceUtil.isNotBlank(input.getEndTime()))
            queryWrapper.lambda().ge(PlantPowerDataEnt::getDataDate, input.getEndTime());
        queryWrapper.lambda().orderByDesc(PlantPowerDataEnt::getDataDate);
        return XMapperHelper.query(mapper, input, queryWrapper, QueryPlantPowerDataOutput.class);
    }
}