package pps.core.prediction.service;

import pps.core.prediction.entity.ThirdActivePowerView;
import pps.core.prediction.mapper.ThirdActivePowerViewMapper;
import pps.core.prediction.service.data.third_active_power.GetThirdActivePowerOutput;
import pps.core.prediction.service.data.third_active_power_daily_update.GetThirdActivePowerDailyUpdateInput;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XListResult;
import xstartup.feature.api.annotation.XApiPost;

import java.util.List;

/**
 * 第三方有功功率
 *
 * @author ZWT
 * @date 2024/03/19
 */
@XText("第三方有功功率")
@XService
public class ThirdActivePowerService {

    /**
     * 有功功率--用能曲线
     * POST /prediction/third-active-power/get-active-power-list
     * 接口ID：157089363
     * 接口地址：https://app.apifox.com/project/3196988/apis/api-157089363
     *
     * @param context 上下文
     * @param input   输入
     * @return {@link XListResult}<{@link GetThirdActivePowerOutput}>
     */
    @XText("有功功率--用能曲线")
    @XApiPost
    public XListResult<GetThirdActivePowerOutput> getActivePowerList(XContext context, GetThirdActivePowerDailyUpdateInput input) {
        ThirdActivePowerViewMapper mapper = context.getBean(ThirdActivePowerViewMapper.class);
        List<ThirdActivePowerView> list = mapper.selectEnergyUseCurve(ThirdActivePowerView.builder()
                .stationName(input.getStationName())
                .createDate(input.getQueryDate())
                .build());
        return XListResult.success(XCopyUtils.copyNewList(list, GetThirdActivePowerOutput.class));
    }

    /*---------------------------------- 私有方法 ----------------------------------*/


}
